diff --git a/src/backend/access/gist/gistscan.c b/src/backend/access/gist/gistscan.c
new file mode 100644
index cc8d818..991858f
*** a/src/backend/access/gist/gistscan.c
--- b/src/backend/access/gist/gistscan.c
*************** pairingheap_GISTSearchItem_cmp(const pai
*** 41,49 ****
  
  	/* Heap items go before inner pages, to ensure a depth-first search */
  	if (GISTSearchItemIsHeap(*sa) && !GISTSearchItemIsHeap(*sb))
- 		return -1;
- 	if (!GISTSearchItemIsHeap(*sa) && GISTSearchItemIsHeap(*sb))
  		return 1;
  
  	return 0;
  }
--- 41,49 ----
  
  	/* Heap items go before inner pages, to ensure a depth-first search */
  	if (GISTSearchItemIsHeap(*sa) && !GISTSearchItemIsHeap(*sb))
  		return 1;
+ 	if (!GISTSearchItemIsHeap(*sa) && GISTSearchItemIsHeap(*sb))
+ 		return -1;
  
  	return 0;
  }
